package SPatterns;
#Erik Velldal, 2003, erikve@ilf.uio.no


use diagnostics;
use strict;
#require v5.5;


use locale;
use POSIX qw(locale_h);
setlocale(LC_ALL, "norwegian"); 




use Exporter;
use vars qw/@ISA @EXPORT/;
@ISA = qw(Exporter);


@EXPORT = qw/

    $OSLO_BERGEN_V

    $CONT_WORD_POS_PAT $HEADER $WORD_FORM_B_PAT  $WORD_FORM_PAT
    $SENTENCE_DELIM $LETTER $LEMMA $COMMA_PAT $CHARACTER

    $S_GR $SUBJ $I_OBJ $OBJ $KOMMA $CLB  $ADV

    $SUBST_MOD_PAT $P_UTFYLL $DET_MOD_PAT $S_PRED $SBU_REL $ADJ_MOD  
    
    
    $VERB_PAT $VERB_C_PAT $VERB_NO_AUX_PAT $PRED_VERB_PAT 
    $VERB_DITRANS_NO_AUX_PAT $PART_VERB_PAT $PART_ADV_VERB_PAT 
    $VERB_NO_INF_NO_AUX_PAT $PART_VERB_NO_AUX_PAT
    
    
    $NOMINAL_B_PAT $NOMINAL_C_PAT $NOMINAL_SUBJ_B_PAT $PRON_B_PAT
    $NOUN_PAT $NOUN_SUBJ_PAT $NOUN_OBJ_PAT $NOUN_IND_OBJ_PAT
    $UNAMBIG_NOUN_SUBJ_PAT $POSS_NOUN_PAT $DET_POSS_NOUN_PAT
    $NOUN_MOD_PAT $NOUN_PREP_FILL_PAT $NOUN_SUBJ_PRED_PAT 
    
    
    $ENUM_CONJ_B_PAT $ADJ_MOD_PAT $ORDINAL_PAT $PREP_PAT $SUBJ_C_PAT 
    $SUBJ_PRED_C_PAT $ADJ_SUBJ_PRED_PAT $POSS_NOUN_SUBJ_PRED_PAT
    $SBU_REL_B_PAT $SBU_REL_OR_SGR_B_PAT $SBU_REL_OR_SGR_OR_NOM_SUBJ

      
    /;





#     =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#                       Global Patterns                     
#     =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

    

our ($CONT_WORD_POS_PAT, $HEADER);

our ($S_GR, $SUBJ, $I_OBJ, $OBJ, $KOMMA, $CLB, $SUBST_MOD_PAT, $P_UTFYLL,
     $DET_MOD_PAT, $S_PRED, $SBU_REL, $ADJ_MOD, $ADV);


our ($SENTENCE_DELIM, $LETTER, $LEMMA, $LEMMA_B, $COMMA_PAT, $WORD_FORM_B_PAT,
     $WORD_FORM_PAT, $CHARACTER, $ENUM_CONJ_B_PAT); 



our ($VERB_PAT, $VERB_C_PAT, $VERB_NO_AUX_PAT, $PRED_VERB_PAT, 
     $VERB_DITRANS_NO_AUX_PAT, $PART_VERB_PAT, $PART_ADV_VERB_PAT, 
     $VERB_NO_INF_NO_AUX_PAT, $PART_VERB_NO_AUX_PAT);


our ($NOMINAL_B_PAT, $NOMINAL_C_PAT, $NOMINAL_SUBJ_B_PAT, $PRON_B_PAT,
     $NOUN_PAT, $NOUN_SUBJ_PAT, $NOUN_OBJ_PAT, $NOUN_IND_OBJ_PAT,
     $UNAMBIG_NOUN_SUBJ_PAT, $POSS_NOUN_PAT, $DET_POSS_NOUN_PAT,
     $NOUN_MOD_PAT, $NOUN_PREP_FILL_PAT, $NOUN_SUBJ_PRED_PAT); 


our ($ADJ_MOD_PAT, $ORDINAL_PAT, $PREP_PAT, $SUBJ_C_PAT, 
     $SUBJ_PRED_C_PAT, $ADJ_SUBJ_PRED_PAT, $POSS_NOUN_SUBJ_PRED_PAT,
     $SBU_REL_B_PAT, $SBU_REL_OR_SGR_B_PAT, $SBU_REL_OR_SGR_OR_NOM_SUBJ);

  


 


# -- -- -- -- -- --  Grammatical Tags  -- -- -- -- -- -- #



#/\@(?:s-gr|S-GR)/ betyr det samme som /\@s-gr/i eller /\@(?i:s-gr)/ er muligens noe mer effektivt.

$S_GR = qr/\@(?:s-gr|S-GR)/;  # @s-gr

$I_OBJ = qr/\@(?:i-obj|I-OBJ)/; # \@i-obj

$OBJ = qr/\@(?:obj|OBJ)/;  # @obj

$SUBJ = qr/\@(?:subj|SUBJ)/;  # @subj

$CLB = qr/clb|CLB/;

$KOMMA = qr/komma|KOMMA/;

$SUBST_MOD_PAT = qr/\@(?i:subst)>/;

$DET_MOD_PAT = qr/\@(?i:det)>/;

$ADJ_MOD = qr/\@(?i:adj)>/;

$P_UTFYLL = qr/\@<(?i:p-utfyll)/; 

$S_PRED = qr/\@(?i:s-pred)/;

$SBU_REL = qr/\@<(?i:sbu-rel)/;
	 
$ADV = qr/\@(?i:adv)/;   

# -- -- -- -- -- --  delimiters  -- -- -- -- -- -- #


our $OSLO_BERGEN_V = 1; 
   
 
#original oslo-versjon:
#$SENTENCE_DELIM = qr/CLB.*?\@\?\?\?/;


$HEADER = qr/^\s+\"\$\|\"\s(?i:clb)\s<(?i:overskrift)>/;

#foranstilt whitespace i oslo-bergen-versjonen: /^\s{8}.../
#i gamle oslo-versjonen: /^\t.../


#sentence delimiter
$SENTENCE_DELIM = qr/<<</;
#brukes i slurp_sentence
#("oslo-bergen"-versjon)



$COMMA_PAT = qr/^\s+\"\$\,\"\s.*?<$KOMMA>/; 
#brukes i verb_noun_subj


$ENUM_CONJ_B_PAT = qr/^\s+\"(og|eller)\"/;
   


$CHARACTER = qr/[^>\"]/;
#$CHARACTER = qr/[*\s\d\w,.|?!\$<>\":;\\\/-]/; #fungerer med use locale; \w dekker da  etc.
#stjerne '*' og dollar '$' er med pga oslo-versjonen.



$LETTER = qr/[*.\s\d\w-]/; #fungerer med use locale; \w dekker da  etc.
#$LETTER = qr/[^"]/; 
#har valgt en mere restriktiv definisjon av $letter for slik  unng mange "sty-ord".
#stjerne '*' er med pga oslo-versjonen.





$LEMMA =  qr/^\s+\"\*?($LETTER*)\"/;
#valgfri stjerne '*' er med pga oslo-versjonen.
$LEMMA_B =  qr/^\s+\"\*?(?:$LETTER*)\"/;  #non-capturing


$WORD_FORM_B_PAT = qr/^\"<$CHARACTER*>\"/;
#brukes i (rev)find_constituent



#my $WORD_FORM_PAT = '^\"<\*?([\s0-9a-zA-Z,.|?!\$<>\";-]*)>\"';  #<=5_004 
$WORD_FORM_PAT = qr/^\"<($CHARACTER*)>\"/;
#brukes bla. i print_sent_word_form



# -- -- -- -- -- --  verb  -- -- -- -- -- -- #




$VERB_C_PAT = qr/(?=\sverb\s)(?>(.*))/;  
#brukes i noun_prep_noun
#sjekker for \sverb+s ikke bare verb for  unng at f.eks substantivet
#"verb" fanges som et verb :)  



#verb. (only the lemma is captured.)
$VERB_PAT = qr/$LEMMA\sverb\s/; 
#brukes i noun_prep_noun


#verb, not auxiliary
$VERB_NO_AUX_PAT = qr/$VERB_PAT(?!.*aux)/;
#brukes i de fleste funksjoner knyttet til verb-relasjoner


#predicative verb
$PRED_VERB_PAT = qr/${VERB_PAT}.*?pr\d\d?\s/;
#brukes i noun_subj_pred


#verb, not auxiliary, ditransitive:
#$VERB_DITRANS_NO_AUX_PAT = $VERB_PAT . '.*\sd\d\s(?!.*aux)';
$VERB_DITRANS_NO_AUX_PAT = qr/$VERB_NO_AUX_PAT.*?\sd\d\s/;
#den frste versjonen er kanskje mer effektiv.?!
#brukes i verb_noun_ind_obj
#\sd\d\s matches d1 - d9, ditransitive verb codes.
#(?!.*aux) excludes, for example, ditransitive uses of copula.


#verb, with particle/prepositional object.
$PART_VERB_PAT = qr/$VERB_PAT.*?pa\d\d?\s/;
#tidligere brukt i noun_prep_noun..


#non-auxiliary particle verb
$PART_VERB_NO_AUX_PAT = qr/$VERB_NO_AUX_PAT.*?pa\d\d?\s/; 



#verb, with adverbial or particle/prepositional object, not auxiliary.
$PART_ADV_VERB_PAT = qr/$VERB_PAT.*?\s(?:pa\d\d?|a\d\d?)\s/;
#brukes i noun_prep_noun


#not infinitive verb, not auxiliary
$VERB_NO_INF_NO_AUX_PAT = qr/$VERB_NO_AUX_PAT(?!inf)/;
#brukes i verb_noun_subj


#ad "auxiliary verbs": 
#aux1? auxp, auxm. etc i gamle-korpuset.. underspesifisert her.. 
#Eks: bli, burde, f, ha, kunne, monne, mtte, skulle, ville, vre



# -- -- -- -- -- --  adjective  -- -- -- -- -- -- #


$ADJ_MOD_PAT = qr/$LEMMA\s.*$ADJ_MOD/; 


$ORDINAL_PAT = qr/<ordenstall>/;

  
# -- -- -- -- -- --  nouns  -- -- -- -- -- -- #
 

#noun
$NOUN_PAT = qr/$LEMMA\ssubst\s/; 

#nominal (noun or pronoun)
$NOMINAL_B_PAT = qr/\s(?:subst|pron)\s/;
$NOMINAL_C_PAT = qr/(?=$NOMINAL_B_PAT)(?>(.*))/;
#brukes av noun_prep_noun 

#pronominal
$PRON_B_PAT = qr/\spron\s/;   
#brukes av noun_subj_obj_sbu_rel_verb


#noun object
$NOUN_OBJ_PAT = qr/$NOUN_PAT.*$OBJ/;



#noun indirect object
$NOUN_IND_OBJ_PAT = qr/$NOUN_PAT.*$I_OBJ/;  


#noun subject
$NOUN_SUBJ_PAT = qr/$NOUN_PAT.*$SUBJ/;  


#nominal subject
$NOMINAL_SUBJ_B_PAT = qr/$NOMINAL_B_PAT.*$SUBJ/;
#brukes i noun_subj_obj_sbu_rel_verb


#unambiguously tagged nominal subject
$UNAMBIG_NOUN_SUBJ_PAT = qr/$NOUN_PAT(?!.*$OBJ).*$SUBJ/;
#brukes i verb_noun_subj


#subject (any P-O-S)
$SUBJ_C_PAT = qr/(^\s+\"$LETTER*\".*$SUBJ.*)/; 
#brukes i noun_subj_pred 


#nominal genetiv (not necessarily a determinator, as opposed to $DET_POSS_NOUN_PAT)
$POSS_NOUN_PAT = qr/$NOUN_PAT.*?gen\s/; 
#brukes for  trekke ut possesiv-relasjoner ved subjektspredikativ i noun_subj_pred
#        "hund" subst mask appell be ent gen @subj @s-pred 




#nominal genetiv determinator
$DET_POSS_NOUN_PAT = qr/$POSS_NOUN_PAT.*?$DET_MOD_PAT/;  
#brukes i poss_noun_mod. slr til p f.eks;
#        "hjerne" subst mask appell be ent gen @det> 


#@subst>
$NOUN_MOD_PAT = qr/$NOUN_PAT(?!.*?prop).*$SUBST_MOD_PAT/;  
#brukes i noun_mod_noun.
#        "million" subst mask appell ub ent @subst> 


#substantiv som p-utfylling:
$NOUN_PREP_FILL_PAT = qr/$NOUN_PAT.*$P_UTFYLL/;
#brukes i noun_prep_noun


#preposisjon
$PREP_PAT = qr/$LEMMA\sprep\s/; 
#brukes bla i noun_prep_noun




# -- -- -- -- -- --  predicatives  -- -- -- -- -- -- #


#$subj_pred_pat, $NOUN_SUBJ_PRED_PAT og $ADJ_SUBJ_PRED_PAT brukes i
#noun_subj_pred 



$SUBJ_PRED_C_PAT = qr/($LEMMA\s.*$S_PRED)/; 
 


$NOUN_SUBJ_PRED_PAT = qr/$NOUN_PAT.*$S_PRED/;   
#       "Oslo" subst prop @subj @s-pred 



$ADJ_SUBJ_PRED_PAT = qr/$LEMMA\sadj\s.*$S_PRED/; 
#        "paranoid" adj pos m/f ub ent @s-pred 


$POSS_NOUN_SUBJ_PRED_PAT = qr/$POSS_NOUN_PAT.*$S_PRED/; 





# -- -- -- -- -- --  subjunctions  -- -- -- -- -- -- #


#relativt pronomen "som", relativiserte objekter og subjekter

#brukes av noun_subj_obj_sbu_rel_verb



$SBU_REL_B_PAT =  qr/\s+\"som\"\ssbu\s\s?$SBU_REL/;

$SBU_REL_OR_SGR_B_PAT = qr/$S_GR|$SBU_REL/;

$SBU_REL_OR_SGR_OR_NOM_SUBJ = qr/$SBU_REL_OR_SGR_B_PAT|(?:$NOMINAL_SUBJ_B_PAT)/;




$CONT_WORD_POS_PAT = qr/$LEMMA\s(?:subst|verb|adj|adv)/; 





1;


